﻿package cust_Modules.Controls
{
    import cust_Modules.Controls.*
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.events.KeyboardEvent;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	import flash.events.Event;

    public class ComboButtonChild extends MovieClip
    {
		var _label:Label;
		var _reset:Button;
		var _left:Button;
		var _right:Button;
		var _inputField:TextField;
		
		var _leftf:Function;
		var _rightf:Function;
		var _resetf:Function;
		var _settext:Function;
		var _setfunc:Function;
		public var _anim:Object;
		var _applyall:Function;
		
		var _buttonsize:int = 18;
		var _labelsize:int = 150;
		var _inputsize:int = 65;
		var _editing:Boolean = false;
		var _update:Function;
		var _delay:int = 6;
		var _curdelay:int = 6;
		var _counter:int = 0;
		var _curdelayl:int = 6;
		var _counterl:int = 0;
		var _gapsize:int = 3;
		var _maxchars:int = 10;
	
		
		public function ComboButtonChild(type:int, xbase:int, ybase:int, mytext:String, leftf:Function, rightf:Function, reset:Function, settext:Function, setfunc:Function,anim:Object, applyall:Function, updatef:Function, ls:int, bs:int, ips:int)
		{
		_buttonsize = bs;
		_inputsize = ips;
		_labelsize = ls;
		_setfunc = setfunc;
		_anim = anim;
		_settext = settext;
		_resetf = reset;
		_rightf = rightf;
		_leftf = leftf;
		_applyall = applyall;
		_update = updatef;
		
		var tfor = new TextFormat();
		tfor.size = 12;
		var tforsmall = new TextFormat();
		tforsmall.size = 12 - Math.max(0,(mytext.length - 20) / 4);
		
		
		_label = new Label(_labelsize,_buttonsize,mytext);
		
		_label.tf.backgroundColor = 0xffffff;
		_label.tf.background = true;
		_label.tf.border = true;
		if(_labelsize > 150)
		{
		_label.tf.setTextFormat(tfor);
		}
		else
		{
		_label.tf.setTextFormat(tforsmall);
		}
		
		_reset = new Button(_buttonsize,_buttonsize,"x");
		_reset.textLabel.tf.setTextFormat(tfor);
		_reset.addEventListener("buttonClicked", resetpressed);
		
		_left = new Button(_buttonsize,_buttonsize,"<");
		_left.textLabel.tf.setTextFormat(tfor);
		//_left.textLabel.tf.backgroundColor = 0xeeeeee;
		_left.addEventListener("buttonClicked", leftpressed);
		//_left.addEventListener(Event.ENTER_FRAME,entframe);
		_left.pressactionf = resettimers;
		_left.pressedf = entframel;
		
		_inputField = new TextField();
		_inputField.width = _inputsize;
		_inputField.height = _buttonsize;
		_inputField.mouseEnabled = true;
		_inputField.selectable = true;
		_inputField.border = true;
		_inputField.backgroundColor = 0xeeeeee;
		_inputField.background = true;
		_inputField.setTextFormat(tfor);
		
		_inputField.type = "input";
		_inputField.restrict = "\-.0-9";
		if(_inputsize > 80)
		{
		_maxchars = 20;
		
		}
		else
		{
		_maxchars = 10;
		}
		_inputField.maxChars = _maxchars;
		_inputField.addEventListener(FocusEvent.FOCUS_IN, togglekeys);
		_inputField.addEventListener(KeyboardEvent.KEY_DOWN,textInputCapture);
			
		
		_right = new Button(_buttonsize,_buttonsize,">");
		_right.textLabel.tf.setTextFormat(tfor);
		//_right.textLabel.tf.backgroundColor = 0xeeeeee;
		_right.addEventListener("buttonClicked", rightpressed);
		_right.pressactionf = resettimers;
		_right.pressedf = entframe;
		
		if(type == 0)
		{
			_label.x = xbase;
			_label.y = ybase;
			_reset.x = xbase + _labelsize;
			_reset.y = ybase;
			_left.x = xbase;
			_left.y = ybase + _buttonsize;
			_inputField.x = xbase + _buttonsize;
			_inputField.y = ybase + _buttonsize;
			_right.x = xbase + _buttonsize + _inputsize;
			_right.y = ybase + _buttonsize;
		}
		else
		{
			
			_label.x = xbase;
			_label.y = ybase;
			_left.x = _label.x + _labelsize + _gapsize;
			_left.y = ybase;
			_inputField.x = _left.x + _buttonsize;
			_inputField.y = ybase;
			_right.x = _inputField.x + _inputsize;
			_right.y = ybase;
			
			_reset.x = _right.x + _buttonsize + _gapsize;
			_reset.y = ybase;
		}
		
		update();
		addChild(_label);
		addChild(_left);
		addChild(_right);
		addChild(_reset);
		addChild(_inputField);
		
		
		}
		
		
		function resettimers(){ _counterl = _delay; _curdelayl = _delay;  _counter = _delay; _curdelay = _delay;}
		
		function entframe()
		{
			if(_right.pressed)
			{
				if(_counter <= 0)
				{
					_curdelay = Math.max(0,_curdelay / 2);
					_counter = _curdelay;
					rightpressed(null);
				}
				else
				{
					_counter--;
				}
			}
		}
		
		function entframel()
		{
			
			if(_left.pressed)
			{
				if(_counterl <= 0)
				{
					_curdelayl = Math.max(0,_curdelayl / 2);
					_counterl = _curdelayl;
					leftpressed(null);
				}
				else
				{
					_counterl--;
				}
			}
			
		}
		
		
		function togglekeys(e)
		{
			if(_anim.bstate) _anim.togglekeys(null);
			_editing = true;
		}
		
		function textInputCapture(event:KeyboardEvent):void 
		{ 
			if(event.charCode == 13)
			{
				if(!isNaN(Number(_inputField.text)) && _inputField.text != "")
				{
					_setfunc(Number(_inputField.text)); 
				}
				update();
				stage.focus = _anim.stage;
			
				if(!_anim.bstate) _anim.togglekeys(null);
				_editing = false;
			}
			
		}
		
		function requestupdatetext()
		{
			if(!_editing) _inputField.text = _settext().substr(0,_maxchars);
		}
		
		function update()
		{
			if(_update != null) _update();
			_applyall();
			_inputField.text = _settext().substr(0,_maxchars);
		}
		
		function leftpressed(e)
		{
			_leftf();
			update();
		}
		
		function rightpressed(e)
		{
			_rightf();
			update();
		}
		
		function resetpressed(e)
		{
			_resetf();
			update();
		}

    }
}
