﻿package Modules.Controls
{
    import flash.events.*;

    public class ListButton extends Button
    {
        private var lb:ListBox;

        public function ListButton(param1:Number, param2:Number, param3:String, param4:ListBox)
        {
            super(param1, param2, param3);
            this.lb = param4;
            return;
        }// end function

        public function getPressed() : Boolean
        {
            return pressed;
        }// end function

        public function setPressed(param1:Boolean) : void
        {
            pressed = param1;
            return;
        }// end function

        override protected function clicked(event:MouseEvent) : void
        {
            fadeTicks = fadeTicksMax;
            textLabel.tf.textColor = glyphClickCol;
            stage.addEventListener(MouseEvent.MOUSE_UP, this.mouseReleased);
            return;
        }// end function

        override protected function mouseReleased(event:MouseEvent) : void
        {
            var _loc_3:* = 0;
            var _loc_4:* = undefined;
            var _loc_2:* = this.getPressed();
            if (hover && this.lb)
            {
                if (!_loc_2)
                {
                    this.lb.notifyEvent(this);
                }
                _loc_3 = 0;
                while (_loc_3 < this.lb.sa.controls.length)
                {
                    
                    _loc_4 = this.lb.sa.controls[_loc_3];
                    _loc_4.setPressed(false);
                    _loc_3++;
                }
                this.setPressed(true);
            }
            if (pressed)
            {
                textLabel.tf.textColor = glyphClickCol;
            }
            stage.removeEventListener(MouseEvent.MOUSE_UP, this.mouseReleased);
            return;
        }// end function

        override protected function refreshButton() : void
        {
            ControlGraphics.drawRect(background, new Rectangle(0, 0, buttonWidth, buttonHeight), backgroundIdleCol, 0, 1, 0, 0, true);
            ControlGraphics.drawRect(background, new Rectangle(0, 0, buttonWidth, buttonHeight), backgroundClickCol, outlineCol, pressed ? (1) : (0), outlineOpacity, outlineThickness, false);
            ControlGraphics.drawRect(background, new Rectangle(0, 0, buttonWidth, buttonHeight), backgroundHoverCol, 0, fadeTicks / fadeTicksMax, 0, 0, false);
            return;
        }// end function

    }
}
