﻿package cust_Modules.Controls
{
    import flash.display.*;
    import flash.geom.*;

    public class MarkerSlider extends Slider
    {
        public var barMask:MovieClip;
        private var sliderSize:int = 10;

        public function MarkerSlider(param1:Number, param2:Number)
        {
            this.barMask = new MovieClip();
            super(param1, param2);
            addChild(this.barMask);
            this.barMask.mouseEnabled = false;
            bar.mask = this.barMask;
            return;
        }// end function

        override protected function refreshSlider() : void
        {
            var _loc_1:* = new Rectangle(Math.min(Math.max(currentValue * barWidth - this.sliderSize / 2, 0), barWidth - this.sliderSize), 0, this.sliderSize, barHeight);
            var _loc_2:* = new Rectangle(0, 0, barWidth, barHeight);
            ControlGraphics.drawRect(bar, _loc_2, glyphIdleCol, 0, 1, 0, 0, true);
            if (hover)
            {
                ControlGraphics.drawRect(bar, _loc_2, glyphHoverCol, 0, 1, 0, 0, false);
            }
            if (dragging)
            {
                ControlGraphics.drawRect(bar, _loc_2, glyphIdleCol, 0, 1, 0, 0, false);
            }
            ControlGraphics.drawRect(bar, new Rectangle(0, 0, barWidth, barHeight), 0, outlineCol, 0, 1, outlineThickness, false);
            ControlGraphics.drawRect(this.barMask, _loc_1);
            return;
        }// end function

    }
}
