﻿package Modules.Controls
{
    import flash.events.*;

    public class RadioButton extends Checkbox
    {
        private var radioGroup:Array;

        public function RadioButton(param1:Number, param2:Number)
        {
            super(param1, param2);
            this.radioGroup = new Array();
            return;
        }// end function

        override protected function clicked(event:MouseEvent) : void
        {
            pressed = true;
            fadeTicks = fadeTicksMax;
            stage.addEventListener(MouseEvent.MOUSE_UP, this.mouseReleased);
            return;
        }// end function

        override protected function mouseReleased(event:MouseEvent) : void
        {
            var _loc_2:* = undefined;
            var _loc_3:* = 0;
            var _loc_4:* = null;
            if (hover)
            {
                _loc_2 = getChecked();
                _loc_3 = 0;
                while (_loc_3 < this.radioGroup.length)
                {
                    
                    _loc_4 = this.radioGroup[_loc_3];
                    _loc_4.setChecked(false);
                    _loc_3++;
                }
                setChecked(true);
                if (!_loc_2)
                {
                    dispatchEvent(new RadioButtonClickedEvent(this, hover));
                }
            }
            return;
        }// end function

        public function linkTo(param1:RadioButton)
        {
            var _loc_3:* = null;
            if (this.radioGroup.indexOf(param1) != -1)
            {
                return;
            }
            this.radioGroup.push(param1);
            var _loc_2:* = 0;
            while (_loc_2 < this.radioGroup.length)
            {
                
                _loc_3 = this.radioGroup[_loc_2];
                _loc_3.linkTo(param1);
                _loc_3.linkTo(this);
                _loc_2++;
            }
            return;
        }// end function

        override protected function refreshCheckbox() : void
        {
            ControlGraphics.drawCirc(background, new Point(checkboxWidth / 2, checkboxHeight / 2), checkboxWidth / 2, backgroundIdleCol, 0, 1, 0);
            ControlGraphics.drawCirc(background, new Point(checkboxWidth / 2, checkboxHeight / 2), checkboxWidth / 2, backgroundHoverCol, outlineCol, fadeTicks / fadeTicksMax, outlineOpacity, outlineThickness, false);
            if (checked)
            {
                if (hover && !pressed)
                {
                    ControlGraphics.drawCirc(check, new Point(checkboxWidth / 2, checkboxHeight / 2), checkboxWidth * 0.3, foregroundHoverCol, 0, 1, 0);
                }
                else
                {
                    ControlGraphics.drawCirc(check, new Point(checkboxWidth / 2, checkboxHeight / 2), checkboxWidth * 0.3, foregroundIdleCol, 0, 1, 0);
                }
            }
            return;
        }// end function

    }
}
