﻿package cust_Modules.Controls
{
    import cust_Modules.Controls.ComboButtonChild;
    import flash.display.MovieClip;
	
    public class ComboButton extends MovieClip
    {
		var _currentx:int = 0;
		var _currenty:int = 0;
		var _buttons:Array = new Array();
		var _type:int = 0;
		var _anim:Object;
		var _step:int = 0;
		var _applyall:Function;
		var _pages:Array = new Array();
		var _curpage:int = 0;
		
		var _ls:int = 145;
		var _bs:int = 18;
		var _ips:int = 64;
		
        public function ComboButton(xbase:int, ybase:int, type:int, anim:Object, step:int, applyall:Function)
        {
            _currentx = xbase;
			_currenty = ybase;
			_type = type;
			_anim = anim;
			_step = step;
			_applyall = applyall;
			_curpage = 0;
			addpage();
        }// end function

		public function setinputsize(ips:int)
		{
			_ips = ips;
		}
		public function setlabelsize(ls:int)
		{
			_ls = ls;
		}	
		public function setbuttonsize(bs:int)
		{
			_bs = bs;
		}


		public function addButton(mytext:String, leftf:Function, rightf:Function, reset:Function, settext:Function, setfunc:Function, updatef:Function = null)
		{
			var cbc:ComboButtonChild = new ComboButtonChild(_type, _currentx, _currenty, mytext, leftf, rightf, reset, settext,setfunc,_anim, _applyall, updatef, _ls, _bs, _ips);
			_currenty += _step;
			//_buttons.push(cbc);
			_buttons[_curpage].push(cbc);
			_pages[_curpage].addChild(cbc);
		}
		
		public function refreshtext()
		{
			for(var i = 0; i < _buttons.length; i++)
			{
				for(var j = 0; j < _buttons[i].length; j++)
				{
					_buttons[i][j].requestupdatetext();
				}
			}
		}
		
		public function refreshtextthispage(p:int)
		{
			for(var j = 0; j < _buttons[p].length; j++)
			{
				_buttons[p][j].requestupdatetext();
			}
		}
		
		public function addpage()
		{
			var apage:MovieClip = new MovieClip();
			addChild(apage);
			_pages.push(apage);
			_buttons.push(new Array());
		}
		
		public function setpage(p:int)
		{
			_curpage = p;
			for(var i = 0; i < _pages.length; i++)
			{
				_pages[i].visible = i == p;
			}
		}
		
		public function addgap(gap:int)
		{
			_currenty += gap;
		}
		public function addtab(tab:int)
		{
			_currentx += tab;
		}
		
		public function setx(tx:int)
		{
			_currentx = tx;
		}
		public function sety(ty:int)
		{
			_currenty = ty;
		}

    }
}
