﻿package cust_Modules.Controls
{
    import flash.display.*;
    import flash.geom.*;

    public class ControlGraphics extends Object
    {

        public function ControlGraphics()
        {
            return;
        }// end function

        public static function clearGraphics(param1:MovieClip)
        {
            param1.graphics.clear();
            return;
        }// end function

        public static function drawCirc(param1:MovieClip, param2:Point, param3:Number, param4:Number = 0, param5:Number = 0, param6:Number = 1, param7:Number = 1, param8 = 1, param9:Boolean = true) : void
        {
            var _loc_10:* = initDrawing(param1, param4, param5, param6, param7, param8, param9);
            _loc_10.drawCircle(param2.x, param2.y, param3);
            _loc_10.endFill();
            return;
        }// end function

        public static function drawRect(param1:MovieClip, param2:Rectangle, param3:Number = 0, param4:Number = 0, param5:Number = 1, param6:Number = 1, param7:Number = 1, param8:Boolean = true) : void
        {
            var _loc_9:* = initDrawing(param1, param3, param4, param5, param6, param7, param8);
            _loc_9.drawRect(param2.x, param2.y, param2.width, param2.height);
            _loc_9.endFill();
            return;
        }// end function

        private static function initDrawing(param1:MovieClip, param2:Number, param3:Number, param4:Number, param5:Number, param6:Number, param7:Boolean) : Graphics
        {
            if (param7)
            {
                ControlGraphics.clearGraphics(param1);
            }
            var _loc_8:* = param1.graphics;
            _loc_8.beginFill(param2, param4);
            _loc_8.lineStyle(param6, param3, param5);
            return _loc_8;
        }// end function

        public static function drawPolygon(param1:MovieClip, param2:Array, param3:Number = 0, param4:Number = 0, param5:Number = 1, param6:Number = 1, param7:Number = 1, param8:Boolean = true) : void
        {
            var _loc_11:* = null;
            var _loc_9:* = initDrawing(param1, param3, param4, param5, param6, param7, param8);
            _loc_9.moveTo(param2[0].x, param2[0].y);
            var _loc_10:* = 0;
            while (_loc_10 < param2.length)
            {
                
                _loc_11 = param2[_loc_10];
                _loc_9.lineTo(_loc_11.x, _loc_11.y);
                _loc_10++;
            }
            _loc_9.lineTo(param2[0].x, param2[0].y);
            _loc_9.endFill();
            return;
        }// end function

    }
}
