﻿package cust_Modules.Controls
{
    import flash.text.*;

    public class Label extends Control
    {
        public var tf:TextField;
        private var dtf:TextFormat;
        private var labelWidth:Number;
        private var labelHeight:Number;
        private var textSize:int = 24;

        public function Label(param1:Number, param2:Number, param3:String)
        {
            this.tf = new TextField();
            this.labelWidth = param1;
            this.labelHeight = param2;
            this.tf.width = this.labelWidth;
            this.tf.height = this.labelHeight;
            this.tf.mouseEnabled = false;
            this.dtf = new TextFormat("_sans", this.textSize);
            this.dtf.align = "center";
            this.tf.defaultTextFormat = this.dtf;
            this.tf.textColor = glyphIdleCol;
            this.tf.selectable = false;
            this.setLabel(param3);
            addChild(this.tf);
            return;
        }// end function

        public function textFormatting() : TextFormat
        {
            return this.dtf;
        }// end function

        public function updateFormatting() : void
        {
            this.tf.setTextFormat(this.dtf);
            return;
        }// end function

        public function getLabel() : String
        {
            return this.tf.text;
        }// end function

        public function setLabel(param1:String) : void
        {
            this.tf.text = param1;
            this.tf.setTextFormat(this.dtf);
            this.tf.wordWrap = true;
            this.tf.multiline = true;
            this.tf.autoSize = "none";
            x = 0;
            y = 0;
            return;
        }// end function

        public function setTextSize(param1:int)
        {
            this.dtf.size = param1;
            this.tf.setTextFormat(this.dtf);
            return;
        }// end function

    }
}
